--  Generate SQL 
--  Version:                   	V5R4M0 060210 
--  Generated on:              	09/11/08 07:47:00 
--  Relational Database:       	MYI5 
--  Standards Option:          	DB2 UDB iSeries 

-- DROP SCHEMA ITSOBANK;

CREATE SCHEMA ITSOBANK ; 
  
CREATE TABLE ITSOBANK.ACCOUNT ( 
	BALANCE INTEGER NOT NULL , 
	ID VARCHAR(250) NOT NULL , 
	CONSTRAINT ITSOBANK.PK_ACCOUNT PRIMARY KEY( ID ) )   
	; 
  
CREATE TABLE ITSOBANK.ACCOUNTS_CUSTOMERS ( 
	ACCOUNTS_ID FOR COLUMN ACCNTID VARCHAR(250) NOT NULL , 
	CUSTOMERS_SSN FOR COLUMN CUSTSSN VARCHAR(250) NOT NULL , 
	CONSTRAINT ITSOBANK.PK_ACCOUNTS_CUSTO2 PRIMARY KEY( ACCOUNTS_ID , CUSTOMERS_SSN ) )   
	; 

CREATE TABLE ITSOBANK.CUSTOMER ( 
	TITLE VARCHAR(250) DEFAULT NULL , 
	FIRSTNAME VARCHAR(250) DEFAULT NULL , 
	LASTNAME VARCHAR(250) DEFAULT NULL , 
	SSN VARCHAR(250) NOT NULL , 
	CONSTRAINT ITSOBANK.PK_CUSTOMER PRIMARY KEY( SSN ) )   
	; 
  
CREATE TABLE ITSOBANK.TRANSACTIONS ( 
	ID INTEGER GENERATED ALWAYS AS IDENTITY ( 
	START WITH 1 INCREMENT BY 1 
	NO MINVALUE NO MAXVALUE 
	NO CYCLE NO ORDER 
	CACHE 20 ) 
	, 
	TRANSTYPE VARCHAR(32) NOT NULL , 
	TRANSTIME TIMESTAMP DEFAULT NULL , 
	AMOUNT INTEGER NOT NULL , 
	ACCOUNTS_ID FOR COLUMN ACCNTID VARCHAR(250) DEFAULT NULL , 
	CONSTRAINT ITSOBANK.PK_TRANSACTIONS PRIMARY KEY( ID ) )   
	; 
  
ALTER TABLE ITSOBANK.ACCOUNTS_CUSTOMERS 
	ADD CONSTRAINT ITSOBANK.AC_ACCOUNT_FK 
	FOREIGN KEY( ACCOUNTS_ID ) 
	REFERENCES ITSOBANK.ACCOUNT ( ID ) 
	ON DELETE NO ACTION 
	ON UPDATE NO ACTION ; 
  
ALTER TABLE ITSOBANK.ACCOUNTS_CUSTOMERS 
	ADD CONSTRAINT ITSOBANK.AC_CUST_FK 
	FOREIGN KEY( CUSTOMERS_SSN ) 
	REFERENCES ITSOBANK.CUSTOMER ( SSN ) 
	ON DELETE NO ACTION 
	ON UPDATE NO ACTION ; 
  

ALTER TABLE ITSOBANK.TRANSACTIONS 
	ADD CONSTRAINT ITSOBANK.TRANS_ACCOUNT_FK 
	FOREIGN KEY( ACCOUNTS_ID ) 
	REFERENCES ITSOBANK.ACCOUNT ( ID ) 
	ON DELETE NO ACTION 
	ON UPDATE NO ACTION ; 
  