package itso.bank.model.ejb;

import static javax.persistence.FetchType.EAGER;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;

@Entity 
@NamedQueries({@NamedQuery(name="getAccount", query = "SELECT a FROM Account a"),@NamedQuery(name="getAccountOrdered", query = "SELECT a FROM Account a ORDER BY a.id"),
@NamedQuery(name="getAccountByBalance", query = "SELECT a FROM Account a WHERE a.balance = :balance")})
public class Account implements Serializable {
	@Id
	private String id;

	private int balance;

	private static long serialVersionUID = 1L;

	@ManyToMany(mappedBy="accountCollection", fetch=EAGER)
	private List<Customer> customerCollection;

	@OneToMany(mappedBy="accounts", fetch=EAGER, cascade=CascadeType.MERGE)
	
	private List<Transaction> transactionsCollection;

	public Account() {
		super();
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#getId()
	 */
	public String getId() {
		return this.id;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#setId(java.lang.String)
	 */
	public void setId(String id) {
		this.id = id;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#getBalance()
	 */
	public int getBalance() {
		return this.balance;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#setBalance(int)
	 */
	public void setBalance(int balance) {
		this.balance = balance;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#getCustomerCollection()
	 */
	public List<Customer> getCustomerCollection() {
		return this.customerCollection;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#setCustomerCollection(java.util.List)
	 */
	public void setCustomerCollection(List<Customer> customerCollection) {
		this.customerCollection = customerCollection;
	}

	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#getLog()
	 */
	public java.util.Collection<Transaction> getLog()
	{
		
		return java.util.Collections.unmodifiableCollection(getTransactionsCollection());
	}	
	/* (non-Javadoc)
	 * @see itso.bank.model.ejb.AccountLocal#processTransaction(itso.bank.model.ejb.Transaction)
	 */
	public void processTransaction(Transaction transaction) throws Exception
	{
		setBalance(getBalance() + transaction.getSignedAmount());
		if(getTransactionsCollection() == null){
			this.transactionsCollection = new ArrayList<Transaction>();
		}
		getTransactionsCollection().add(transaction);
	}

	/** 
	 */
	public List<Transaction> getTransactionsCollection() {
		return this.transactionsCollection;
	}

	/** 
	 */
	public void setTransactionsCollection(
			List<Transaction> transactionsCollection) {
		this.transactionsCollection = transactionsCollection;
	}

}
