package itso.bank.model.ejb;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import static javax.persistence.FetchType.EAGER;

@Entity
@NamedQueries({
	@NamedQuery(name="getCustomer", query="SELECT c FROM Customer c"),
	@NamedQuery(name="getCustomerOrdered", query = "SELECT c FROM Customer c ORDER BY c.ssn"),
	@NamedQuery(name="getCustomerByLastname", query = "SELECT c FROM Customer c WHERE c.lastname = :lastname"),
	@NamedQuery(name="getCustomerByTitle", query = "SELECT c FROM Customer c WHERE c.title = :title"),
	@NamedQuery(name="getCustomerByFirstname", query = "SELECT c FROM Customer c WHERE c.firstname = :firstname")})
public class Customer implements Serializable {
	@Id
	private String ssn;

	private String lastname;

	private String title;

	private String firstname;

	@ManyToMany(fetch=EAGER)
	@JoinTable(name="ACCOUNTS_CUSTOMERS",
		joinColumns=@JoinColumn(name="CUSTOMERS_SSN"),
		inverseJoinColumns=@JoinColumn(name="ACCOUNTS_ID"))
	private Set<Account> accountCollection;

	private static long serialVersionUID = 1L;

	public Customer() {
		super();
	}

	public String getSsn() {
		return this.ssn;
	}

	public void setSsn(String ssn) {
		this.ssn = ssn;
	}

	public String getLastname() {
		return this.lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public String getTitle() {
		return this.title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getFirstname() {
		return this.firstname;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	public Set<Account> getAccountCollection() {
		return this.accountCollection;
	}

	public void setAccountCollection(Set<Account> accountCollection) {
		this.accountCollection = accountCollection;
	}

}
