package itso.bank.model.ejb;

import static javax.persistence.TemporalType.TIMESTAMP;


import java.io.Serializable;
import java.util.Date;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.TableGenerator;
import javax.persistence.Temporal;

@Entity
@Table(name="TRANSACTIONS")
@Inheritance
@DiscriminatorColumn(name="TRANSTYPE")
@NamedQueries({
	@NamedQuery(name="getTransactions", query="SELECT t FROM Transactions t"),
	@NamedQuery(name="getTransactionsOrdered", query = "SELECT t FROM Transactions t ORDER BY t.id"),
	@NamedQuery(name="getTransactionsByAmount", query = "SELECT t FROM Transactions t WHERE t.amount = :amount"),
	@NamedQuery(name="getTransactionsByTranstime", query = "SELECT t FROM Transactions t WHERE t.transtime = :transtime"),
	@NamedQuery(name="getTransactionsByTranstype", query = "SELECT t FROM Transactions t WHERE t.transtype = :transtype")})
public abstract class Transaction implements Serializable {
	
	//@TableGenerator(name="Trans_Gen", table="TRANS_GEN",pkColumnName="GEN_NAME",valueColumnName="GEN_VAL")
	//@GeneratedValue(strategy=GenerationType.TABLE, generator="Trans_Gen")
	@Id @GeneratedValue(strategy=GenerationType.IDENTITY)
	private String id;

	private int amount;

	private String transtype;
 
	//@ManyToOne(cascade=CascadeType.MERGE) 
	@ManyToOne 
	private Account accounts;

	private static long serialVersionUID = 1L;

	@Temporal(TIMESTAMP)
	private Date transtime;

	public Transaction() {
		super();
		//Initialize to now
		transtime = new Date();
	}

	public String getId() {
		return this.id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public int getAmount() {
		return this.amount;
	}

	public void setAmount(int amount) {
		this.amount = amount;
	}

	public String getTranstype() {
		return this.transtype;
	}

	public void setTranstype(String transtype) {
		this.transtype = transtype;
	}

	public Account getAccounts() {
		return this.accounts;
	}

	public void setAccounts(Account accounts) {
		this.accounts = accounts;
	}

	/** 
	 */
	public Date getTranstime() {
		return this.transtime;
	}

	/** 
	 */
	public void setTranstime(Date transtime) {
		this.transtime = transtime;
	}
	public int getSignedAmount() throws Exception
	{
		throw new Exception("Transaction.getSignedAmount invoked!");
	}
}
